#pragma once

#include "..\\..\\DuiLib\\UIlib.h"

//528(lint)
#define WM_VSCROLL_VIEW (WM_USER + 12345)
//RegisterWindowMessage(_T("VSCROLL_MAIN_VIEW"));

class CScrollBarEx : public WindowImplBase
{
public:
	CScrollBarEx(void);
	~CScrollBarEx(void);
	BOOL Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID);

	// Attributes
	int GetScrollPos() const;
	int SetScrollPos(int nPos, BOOL bRedraw = TRUE);
	void GetScrollRange(LPINT lpMinPos, LPINT lpMaxPos) const;
	void SetScrollRange(int nMinPos, int nMaxPos, BOOL bRedraw = TRUE);
	void ShowScrollBar(BOOL bShow = TRUE);

	BOOL EnableScrollBar(UINT nArrowFlags = ESB_ENABLE_BOTH);

	BOOL SetScrollInfo(LPSCROLLINFO lpScrollInfo, BOOL bRedraw = TRUE);
	BOOL GetScrollInfo(LPSCROLLINFO lpScrollInfo, UINT nMask = SIF_ALL);
	int GetScrollLimit();

	int MoveWindow(RECT *rc);
	BOOL IsWindowEnabled();
	BOOL IsWindowVisible();
	void Notify(TNotifyUI& msg);

public:	
	LPCTSTR GetWindowClassName() const;	
	void OnFinalMessage(HWND hWnd);
	void InitWindow();
	CDuiString GetSkinFile();
	CDuiString GetSkinFolder();
	UILIB_RESOURCETYPE GetResourceType() const;
private:
	CScrollBarUI	*m_pScrollBar;
};
